var exec_child, readdir, stat, writeFile, url, Bundler, Task, TaskPool, _ref;
exec_child = require('child_process').exec;
_ref = require('fs'), readdir = _ref.readdir, stat = _ref.stat, writeFile = _ref.writeFile;
url = require('url');
Bundler = require('./bundler').Bundler;
_ref = require('./task'), Task = _ref.Task, TaskPool = _ref.TaskPool;
/**
 *  Execute a command, and call the callback once it's done.
 *
 *  @param command A string with the command
 *  @param callback The callback to call once done.
 */
function exec(command, callback){
  var env;
  console.log(command);
  env = {};
  __import(env, process.env);
  return exec_child(command, {
    env: env
  }, function(error, stdout, stderr){
    if (stderr) {
      console.log("stderr: " + stderr);
    }
    if (error !== null) {
      console.log("EXEC ERROR: " + error);
    }
    if (callback) {
      return callback(error, stdout, stderr);
    }
  });
}
/**
 *  Recursively walk down a directory and call the callback
 *  for all or part of its contents.
 *
 *  @param dirname The path to the directory
 *  @param pattern An optional pattern against which filenames
 *      are matched.
 *  @param callback The callback to call whenever we find the files.
 *      (abspath, relpath), where abspath is the absolute path of the
 *      file on the filesystem, and relpath is its relative path
 *      compared to dirname.
 */
function walk(dirname, pattern, callback){
  var basedir;
  pattern == null && (pattern = null);
  if (callback == null && pattern !== null && pattern instanceof Function) {
    callback = pattern;
    pattern = null;
  }
  if (!(callback instanceof Function)) {
    throw new Error("callback should be a function");
  }
  basedir = url.resolve(process.cwd() + '/', dirname);
  function _walk(dirn){
    return readdir(dirn, function(err, files){
      var f, abspath, relpath, continueIfDirectory, _i, _len, _results = [];
      for (_i = 0, _len = files.length; _i < _len; ++_i) {
        f = files[_i];
        abspath = url.resolve(process.cwd() + '/', dirn);
        abspath = url.resolve(abspath + '/', f);
        relpath = (dirn + "/" + f).replace(basedir + '/', '');
        if (pattern === null || abspath.match(pattern)) {
          callback(abspath, relpath);
        }
        continueIfDirectory = _fn;
        _results.push(continueIfDirectory(abspath));
      }
      return _results;
      function _fn(abspath){
        return stat(abspath, function(err, stat){
          if (stat.isDirectory()) {
            return _walk(abspath);
          }
        });
      }
    });
  }
  return _walk(basedir);
}
exports.exec = exec;
exports.walk = walk;
exports.Bundler = Bundler;
exports.Task = Task;
exports.TaskPool = TaskPool;
function __import(obj, src){
  var own = {}.hasOwnProperty;
  for (var key in src) if (own.call(src, key)) obj[key] = src[key];
  return obj;
}